﻿Type=Class
Version=5.51
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'WebSocket class
#Region Events
'#Event: get_inputfile(Params as Map)
#End Region
Sub Class_Globals
	Private ws As WebSocket
	Private state As Int
	'Private ScanList, btnScan, ScanListBody, ScanHistoryBody, TakePictureField, TakePicForm As JQueryElement
End Sub

Public Sub Initialize
	
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	Log("WebSocket_Connected")
	ws = WebSocket1
	Dim session As HttpSession = ws.UpgradeRequest.GetSession
	SetMaxTextMessage(10000000)
	'https://www.b4x.com/android/forum/threads/server-automatic-reconnecting-websocket.62054/
	If session.HasAttribute("state") = False Then
		state = Rnd(1, 101)
		session.SetAttribute("state", state)
		Log($"Creating new state. Number = ${state}"$)
	Else
		state = session.GetAttribute("state")
		Log($"Reusing previous state. Number = ${state}"$)
	End If
End Sub

'https://www.b4x.com/android/forum/threads/additional-jserver-web-server-setting-snippets.72625/
Sub SetMaxTextMessage(size As Int)
	Dim jo As JavaObject = ws
	jo = jo.GetFieldJO("session").RunMethod("getPolicy", Null)
	jo.RunMethod("setMaxTextMessageSize", Array(size))
End Sub


Sub SaveDataURL(uri As String, fileDir As String, fileName As String, strict As Boolean)
	'FUTURE: This needs to be fleshed out to ensure the given URI is a valid URI
	'FUTURE: Proper error handling if check fails
	If strict = True Then
		If uri.StartsWith("data:") = False Then
			Log("Not a Data URL")
			Return
		End If
		Dim x As Int
		Dim y As Int
		x = uri.IndexOf(":")
		y = uri.IndexOf(";")
		If x < 0 Or y < 0 Then
			Log("No mime type designation found in supplied URI")
			Return
		End If
		If y <= x Then
			Log(": and ; delimiters wrong")
			Return
		End If
		
		Dim extPos As Int = fileName.LastIndexOf(".")
		If extPos < 0 Then
			Log("File name contains no extension.")
			Return
		End If
		Dim fileExtension As String = fileName.SubString(extPos+1)
		Log($"fileExtension: ${fileExtension}"$)
		Dim mimeType As String
		mimeType = uri.SubString2(x+1,y).ToLowerCase
		'NOTE: May need to work more on this (mime type validation)
		If Main.mimeConfig1.lookupMimeType(fileExtension) <> mimeType Then
			Log($"File extension (${fileExtension}) does not match mime type (${mimeType})"$)
			Return
		End If
		Log($"mimeType in URL: ${mimeType}"$)
	End If
	
	'https://www.b4x.com/android/forum/threads/data-uri-scheme-displaying-a-base64-encoded-image-string.29738/#post-173600
	Dim s As String
	Dim n As Int
	n = uri.IndexOf(",")
	If n < 0 Then
		s = uri
	Else
		s = uri.SubString(n+1)
	End If
	Dim su As StringUtils
	Dim bytes() As Byte = su.DecodeBase64(s)
	Dim In As InputStream
	In.InitializeFromBytesArray(bytes, 0, bytes.Length)
	'This is mime-type agnostic and we're just saving the file. The original code was bmp tied.
	Dim out As OutputStream = File.OpenOutput(fileDir, fileName, False)
	File.Copy2(In, out)
	In.Close
	out.Close
	Return
End Sub

Public Sub get_inputfile(Params As Map)
	Log("Get Input File")
	Dim fileName As String = Params.Get("filename")
	Log($"fileName: ${fileName}"$)
	'Strip out any directory information given in the filename. This should take
	'care of directory escape attempts. Other methods may need to be applied to
	'sanitize a file's name.
	Dim cleanFileName As String = File.getname(fileName)
	Log($"cleanFileName: ${cleanFileName}"$)
	'Note: I'm just dumping files into File.DirApp for demo purposes
	SaveDataURL(Params.Get("dataURL"), File.DirApp, cleanFileName, True)
End Sub

Private Sub WebSocket_Disconnected
'Nothing for now
End Sub